unit Prometheus_Core;

{$Mode Delphi}

interface

uses
	Sysutils,
	sdl,
	
	XMLRead,
	DOM;
	
const	
	CSV_MAXWIDTH: Int64		=			5000;
	CONFIG_MAXPARAMETERS	=			5000;
	XML_MAXTAGS				=			95000;
	XML_PARAMSPERTAG		=			100;
	
type
	Config = record
			Parameter: array [1..5000] of String;
			Value: array [1..5000] of String;
			Length: Int64;
		end;
	Csv = record
			Value: array [1..5000] of string;
			Length: Int64;
		end;
	XMLFile = object
			Document: TXMLDocument;
			
			procedure Load(Src: String);
			
			function GetTagValue(Name_: String): ANSIString;
			function GetTagAttribute(Name_: String; Val: Int64): ANSIString;
			
			procedure Empty();
		end;
	PrometheusEvent = Record
			Type_: String;
			StrVal: String;
			StrVal2: String;
			IntVal: Int64;
			IntVal2: Int64;
		end;
	PromCoreRec = Record
			SdlEvent: pSdl_Event;
			PromEvent: PrometheusEvent;
			Warning: String;
		end;

var
	PromCore: PromCoreRec;

procedure PrometheusCore_Start();

function IntToStr(Int: Int64): String;
function StrToInt(Str: String): Int64;
function StrToReal(Str: String): Real;
function RealToStr(Val: Real): String;

procedure GetInput();

function IsKeyDown(): Boolean;
function IsMouseDown(): Boolean;
function IsKeyUp(): Boolean;
function IsWindowResize(): Boolean;
function IsIdle(): Boolean;
function IsClose(): Boolean;
function IsWmEvent(): Boolean;
function IsMouseUp(): Boolean;
function IsMousePosition: Boolean;

function GetKeyDown(): Int64;
function GetKeyUp(): Int64;
function GetKeyCharByInt(Int: Int64): String;
function GetKeyIntByChar(Chr: Char): Int64;
function GetMouseDown(): String;
function GetMouseUp(): String;
function GetMouseX(): Int64;
function GetMouseY(): Int64;
function GetScreenHeight(): Int64;
function GetScreenWidth(): Int64;

function GetConfigParameter(Conf: Config; Param: String): String;
function LoadConfig(Source: String): Config;
function GetCsValue(Cs: Csv; Id: Int64): String;
function LoadCsv(Source: String): Csv;

procedure Warn(Mesg: String);
function GetWarning(): String;

procedure Pause(Time: Int64);

implementation

{$Include Src/Core/Conversion.pas}
{$Include Src/Core/Warning.pas}
{$Include Src/Core/CSV.pas}
{$Include Src/Core/Config.pas}

function GetScreenHeight(): Int64; //perhaps needs moving to prometheus_video
begin
	GetScreenHeight := Sdl_GetVideoSurface().H;
end;

function GetScreenWidth(): Int64; //perhaps needs moving to prometheus_video
begin
	GetScreenWidth := Sdl_GetVideoSurface().W;
end;

{$Include Src/Core/Info.pas}
{$Include Src/Core/Prometheus.pas}
{$Include Src/Core/Event.pas}
{$Include Src/Core/XML.pas}

end.
